unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  About, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LanguageButton: TButton;
    CalculateButton: TButton;
    EndButton: TButton;
    AboutButton: TButton;
    Bevel1: TBevel;
    Edit1: TEdit;
    ListBox1: TListBox;
    YearLabel: TLabel;
    CorpusCristiLabel: TLabel;
    AshWednesdayLabel: TLabel;
    GoodFridayLabel: TLabel;
    EasterMondayLabel: TLabel;
    AscensionDayLabel: TLabel;
    PentecostLabel: TLabel;
    Image1: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    procedure AboutButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure EndButtonClick(Sender: TObject);
    procedure Form1Show(Sender: TObject);
    procedure LanguageButtonClick(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);

  private
    { Private declarations }
  public
    FUNCTION CalcEasterday(aYear: Word): TDateTime;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AboutButtonClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.Button1Click(Sender: TObject);
VAR
  Easter: TDateTime;
  aYear : WORD;
BEGIN
  ListBox1.Clear;

  TRY
    aYear := StrToInt(Edit1.Text);
  EXCEPT
    if LanguageButton.Caption = 'English' then
      ShowMessage('Fehlerhafte Eingabe des Jahrs!')
    else
      ShowMessage('Incorrect input of the year!');
    Exit;
  END;
  Easter := CalcEasterday(aYear);
  ListBox1.Items.Add(DateToStr(Easter - 46));
  ListBox1.Items.Add(DateToStr(Easter -  2));
  ListBox1.Items.Add(DateToStr(Easter +  1));
  ListBox1.Items.Add(DateToStr(Easter + 39));
  ListBox1.Items.Add(DateToStr(Easter + 50));
  ListBox1.Items.Add(DateToStr(Easter + 60));

end;

procedure TForm1.EndButtonClick(Sender: TObject);
begin
  Close;
end;

FUNCTION TForm1.CalcEasterday(aYear: WORD): TDateTime;
VAR
  A, B, C, D, E, F, G, H, I, J, K, L, M, N: INTEGER;
  vDay, vMonth: WORD;
BEGIN
  A := aYear MOD 19;
  B := aYear DIV 100;
  C := aYear MOD 100;

  D := B DIV 4;
  E := B MOD 4;

  F := (B + 8) DIV 25;
  G := (B - F + 1) DIV 3;
  H := (19 * A + B - D - G + 15) MOD 30;
  I := C DIV 4;
  J := C MOD 4;
  K := (32 + 2 * E + 2 * I - H - J) MOD 7;
  L := (A + 11 * H + 22 * K) DIV 451;
  M := (H + K - 7 * L + 114) DIV 31;
  N := (H + K - 7 * L + 114) MOD 31;

  vDay := N + 1;
  IF M = 3 THEN vMonth := 3 ELSE vMonth := 4;
  Result := EncodeDate(aYear, vMonth, vDay);
END;

procedure TForm1.Form1Show(Sender: TObject);
begin
  Button1CLICK(Sender);
end;

procedure TForm1.LanguageButtonClick(Sender: TObject);
begin
  if LanguageButton.Caption='Deutsch' then begin
    LanguageButton.Caption:='English';
    EndButton.Caption:='Exit';
    AboutButton.Caption:='Info';
    CalculateButton.Caption:='Berechne';
    AshWednesdayLabel.Caption:='Aschermittwoch';
    YearLabel.Caption:='Jahr';
    GoodFridayLabel.Caption:='Karfreitag';
    EasterMondayLabel.Caption:='Ostermontag';
    AscensionDayLabel.Caption:='Himmelfahrt';
    PentecostLabel.Caption:='Pfingsten';
    CorpusCristiLabel.Caption:='Fronleichnam';
  end else begin
    LanguageButton.Caption:='Deutsch';
    EndButton.Caption:='Exit';
    AboutButton.Caption:='About';
    CalculateButton.Caption:='Calculate';
    AshWednesdayLabel.Caption:='Ash Wednesday';
    YearLabel.Caption:='Year';
    GoodFridayLabel.Caption:='Good Friday';
    EasterMondayLabel.Caption:='Easter Monday';
    AscensionDayLabel.Caption:='Ascension Day';
    PentecostLabel.Caption:='Pentecost';
    CorpusCristiLabel.Caption:='Corspus Cristi';
  end;
end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  C: TCanvas;
  s: string;
  w: integer;
begin
  C:=ListBox1.Canvas;
  C.FillRect(Rect);
  s:=ListBox1.Items[Index];
  w:=C.TextWidth(s);
  C.TextRect(Rect, Rect.Left+2+(Rect.Right-Rect.Left-w) div 2, Rect.Top, Listbox1.Items[Index]);
end;

end.
